"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registerServerSource = registerServerSource;
exports.serverSources = void 0;
const serverSources = Object.create(null);
exports.serverSources = serverSources;

function registerServerSource(type, {
  load,
  upToDate,
  update
} = {}) {
  if (type in serverSources) {
    throw new Error(`Duplicate server sources: ${type}`);
  }

  serverSources[type] = {
    load,
    upToDate,
    update
  };
}
//# sourceMappingURL=server-sources.js.map